Package org.apache.commons.math3.optim

# Class BaseMultiStartMultivariateOptimizer<PAIR>

java.lang.Object
org.apache.commons.math3.optim.BaseOptimizer<PAIR>
org.apache.commons.math3.optim.BaseMultivariateOptimizer<PAIR>
org.apache.commons.math3.optim.BaseMultiStartMultivariateOptimizer<PAIR>

Type Parameters:
  `PAIR` - Type of the point/value pair returned by the optimization algorithm.

Direct Known Subclasses:
  `MultiStartMultivariateOptimizer`, `MultiStartMultivariateVectorOptimizer`

public abstract class BaseMultiStartMultivariateOptimizer<PAIR> extends BaseMultivariateOptimizer<PAIR>
Base class multi-start optimizer for a multivariate function.
This class wraps an optimizer in order to use it several times in turn with different starting points (trying to avoid being trapped in a local extremum when looking for a global one). It is not a "user" class.

Since:
  3.0

## Field Summary

### Fields inherited from class org.apache.commons.math3.optim.BaseOptimizer

`evaluations, iterations`

## Constructor Summary

Constructors
Constructor
Description
`BaseMultiStartMultivariateOptimizer(BaseMultivariateOptimizer<PAIR> optimizer, int starts, RandomVectorGenerator generator)`
Create a multi-start optimizer from a single-start optimizer.

## Method Summary

Modifier and Type
Method
Description
`protected abstract void`
`clear()`
Method that will called in order to clear all stored optima.
`protected PAIR`
`doOptimize()`
Performs the bulk of the optimization algorithm.
`int`
`getEvaluations()`
Gets the number of evaluations of the objective function.
`abstract PAIR[]`
`getOptima()`
Gets all the optima found during the last call to `optimize`.
`PAIR`
`optimize(OptimizationData... optData)`
Stores data and performs the optimization.
`protected abstract void`
`store(PAIR optimum)`
Method that will be called in order to store each found optimum.

### Methods inherited from class org.apache.commons.math3.optim.BaseMultivariateOptimizer

`getLowerBound, getStartPoint, getUpperBound, parseOptimizationData`

### Methods inherited from class org.apache.commons.math3.optim.BaseOptimizer

`getConvergenceChecker, getIterations, getMaxEvaluations, getMaxIterations, incrementEvaluationCount, incrementIterationCount, optimize`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### BaseMultiStartMultivariateOptimizer

public BaseMultiStartMultivariateOptimizer(BaseMultivariateOptimizer<PAIR> optimizer, int starts, RandomVectorGenerator generator)
Create a multi-start optimizer from a single-start optimizer.

Note that if there are bounds constraints (see `BaseMultivariateOptimizer.getLowerBound()` and `BaseMultivariateOptimizer.getUpperBound()`), then a simple rejection algorithm is used at each restart. This implies that the random vector generator should have a good probability to generate vectors in the bounded domain, otherwise the rejection algorithm will hit the `BaseOptimizer.getMaxEvaluations()` count without generating a proper restart point. Users must be take great care of the curse of dimensionality.

Parameters:
  `optimizer` - Single-start optimizer to wrap.
  `starts` - Number of starts to perform. If `starts == 1`, the `optimize` will return the same solution as the given `optimizer` would return.
  `generator` - Random vector generator to use for restarts.
Throws:
  `NotStrictlyPositiveException` - if `starts < 1`.

## Method Details

### getEvaluations

public int getEvaluations()
Gets the number of evaluations of the objective function. The number of evaluations corresponds to the last call to the `optimize` method. It is 0 if the method has not been called yet.

Overrides:
  `getEvaluations` in class `BaseOptimizer<PAIR>`
Returns:
  the number of evaluations of the objective function.

### getOptima

public abstract PAIR[] getOptima()
Gets all the optima found during the last call to `optimize`. The optimizer stores all the optima found during a set of restarts. The `optimize` method returns the best point only. This method returns all the points found at the end of each starts, including the best one already returned by the `optimize` method.
The returned array as one element for each start as specified in the constructor. It is ordered with the results from the runs that did converge first, sorted from best to worst objective value (i.e in ascending order if minimizing and in descending order if maximizing), followed by `null` elements corresponding to the runs that did not converge. This means all elements will be `null` if the `optimize` method did throw an exception. This also means that if the first element is not `null`, it is the best point found across all starts.
The behaviour is undefined if this method is called before `optimize`; it will likely throw `NullPointerException`.

Returns:
  an array containing the optima sorted from best to worst.

### optimize

public PAIR optimize(OptimizationData... optData)
Stores data and performs the optimization.

The list of parameters is open-ended so that sub-classes can extend it with arguments specific to their concrete implementations.

When the method is called multiple times, instance data is overwritten only when actually present in the list of arguments: when not specified, data set in a previous call is retained (and thus is optional in subsequent calls).

Important note: Subclasses must override `BaseOptimizer.parseOptimizationData(OptimizationData[])` if they need to register their own options; but then, they must also call `super.parseOptimizationData(optData)` within that method.

Overrides:
  `optimize` in class `BaseMultivariateOptimizer<PAIR>`
Parameters:
  `optData` - Optimization data. In addition to those documented in `BaseOptimizer`, this method will register the following data:
  - `InitialGuess`
  - `SimpleBounds`
Returns:
  a point/value pair that satisfies the convergence criteria.
Throws:
  `MathIllegalStateException` - if `optData` does not contain an instance of `MaxEval` or `InitialGuess`.

### doOptimize

protected PAIR doOptimize()
Performs the bulk of the optimization algorithm.

Specified by:
  `doOptimize` in class `BaseOptimizer<PAIR>`
Returns:
  the point/value pair giving the optimal value of the objective function.

### store

protected abstract void store(PAIR optimum)
Method that will be called in order to store each found optimum.

Parameters:
  `optimum` - Result of an optimization run.

### clear

protected abstract void clear()
Method that will called in order to clear all stored optima.